Package: plasmut
Type: Package
Title: Stratifying mutations observed in cell-free DNA and white blood
        cells as germline, hematopoietic, or somatic
Version: 1.11.0
Authors@R: 
  c(person(given = "Adith",
           family = "Arun",
           role = c("aut", "cre"),
           email = "adith.3.arun@gmail.com"),
    person(given = "Robert",
           family = "Scharpf",
           role = "aut"))
Description: A Bayesian method for quantifying the liklihood that a given plasma mutation arises from clonal hematopoesis or the underlying tumor. It requires sequencing data of the mutation in plasma and white blood cells with the number of distinct and mutant reads in both tissues. We implement a Monte Carlo importance sampling method to assess the likelihood that a mutation arises from the tumor relative to non-tumor origin.
License: Artistic-2.0
Encoding: UTF-8
biocViews: Bayesian, SomaticMutation, GermlineMutation, Sequencing
RoxygenNote: 7.2.3
Imports: tibble, stats, dplyr
Depends: R (>= 4.3.0)
Suggests: knitr, rmarkdown, tidyverse, ggrepel, magrittr, qpdf,
        BiocStyle, biocViews, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/plasmut
git_branch: devel
git_last_commit: 7b0b25f
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:23:06 UTC; biocbuild
Author: Adith Arun [aut, cre],
  Robert Scharpf [aut]
Maintainer: Adith Arun <adith.3.arun@gmail.com>

## plasmut: Weighing the evidence of tumor-specific mutations in cell-free DNA

Adith S. Arun and Robert B. Scharpf  

### Overview

Mutation-based approaches for detection of cancer from cell-free DNA (cfDNA) using liquid biopsies have the potential to track a patient’s response to treatment, enabling effective and timely decisions on therapy. However, mutations arising from clonal hematopoeisis (CH) are common and tumor biopsies for definitive identification of the origin of these mutations is not always available. Sequencing of matched cells from buffy coat and the absence of mutations in these cells has been used as a test to rule-out CH, but uneven sequencing depths between matched cell-free DNA and buffy coat samples and the potential for contamination of buffy coat with circulating tumor cells (CTCs) are not captured by rule-based analyses. This package estimates Bayes factors that weigh the evidence of competing CH- and tumor-origin models of cfDNA mutations detected in cfDNA, requiring only the allele frequencies of high quality alignments available from standard mutation callers.

### Installation

``` r
## install.packages("devtools")
devtools::install_github("cancer-genomics/plasmut")
```
This package is also available through Bioconductor and can be installed using the folllowing command: 

```r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("plasmut")
```


### Usage

Please see the vignette in `doc/plasmut.html`. 

We illustrate this approach on a dataset of cfDNA and matched buffy coat sequencing for patients with metastatic colorectal cancer [(van ’t Erve et al. 2023)](https://pubmed.ncbi.nlm.nih.gov/36534496/). Below, we select four mutations and run the importance sampler for these candidate mutations independently.

``` r
params <- list(ctdna = list(a = 1, b = 9), 
               ctc = list(a = 1, b = 10^3), 
               chip = list(a= 1, b = 9), 
               montecarlo.samples = 50e3, 
               prior.weight = 0.1)
muts <- unite(crcseq, "uid", c(patient, gene), remove = FALSE) %>% 
        group_by(uid) %>% nest()
#Each element of the data column contains a table with the variant and total allele counts in plasma and buffy coat. 
#Run the importance sampler
muts$IS <- muts$data %>% map(importance_sampler, params)
fun <- function(x){
    result <- x$data %>%
        select(-position) %>%
        mutate(bayes_factor = x$IS$bayesfactor$bayesfactor)
    return(result)
}
bf <- apply(muts, 1, fun) 
bf %>% do.call(rbind, .) %>%
    as_tibble() %>%
    select(patient, gene, aa, bayes_factor) %>%
    rename(log_bf=bayes_factor) %>%
    distinct()
```

library(tidyverse)
library(magrittr)
extdir <- system.file("extdata", package="plasmut")
fpath <- file.path(extdir, "cairo5-matched-sequencing.csv")
df <- read_csv(fpath, show_col_types=FALSE) %>%
    type.convert(as.is=TRUE)
cfdna <- df %>%
    select(Gene, Patient, `cfDNA distinct mutant reads`,
           `cfDNA distinct reads`,
           `AAChange`,
           `Nucleotide Position (hg19)`) %>%
    set_colnames(c("gene", "patient", "y", "n",
                   "aa", "position")) %>%
    mutate(analyte="plasma")
buffy <- df %>%
    select(Gene, Patient, `wbc distinct reads`,
           `wbc distinct mutant reads`,
           `AAChange`,
           `Nucleotide Position (hg19)`) %>%
    set_colnames(c("gene", "patient", "n", "y",
                   "aa", "position")) %>%
    mutate(analyte="buffy coat")
crc.data <- bind_rows(cfdna, buffy) %>%
    arrange(patient, aa)
p12 <- crc.data %>%
    filter(patient == 12,
           gene %in% c("APC", "HRAS"))
p13 <- crc.data %>%
    filter(patient == 13, gene=="FGFR2")
p157 <- crc.data %>%
    filter(patient == 157, aa=="M237K")
dat <- bind_rows(p12, p13, p157) %>%
    arrange(patient, gene) %>%
    select(patient, gene, aa, position, analyte, y, n)
crcseq <- dat

output_dir <- "../../data"
if (!dir.exists(output_dir)){
    dir.create(output_dir)
}
save(crcseq, file=file.path(output_dir, "crcseq.rda"))

## ----installation, eval = FALSE-----------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("plasmut")

## ----setup, message=FALSE-----------------------------------------------------
library(magrittr)
library(tidyverse)
library(plasmut)
knitr::opts_chunk$set(cache=TRUE)
lo <- function(p) log(p/(1-p))

## ----data_wrangling-----------------------------------------------------------
## sample data
p53 <- tibble(y=c(4, 0),
              n=c(1000, 600),
              analyte=c("plasma", "buffy coat"),
              mutation="TP53",
              sample_id="id1")
dat <- p53 %>%
    unite("uid", c(sample_id, mutation), remove=FALSE) %>%
    group_by(uid) %>%
    nest()
## required format for plasmut
dat

## ----parameters---------------------------------------------------------------
## Parameters
param.list <- list(ctc=list(a=1, b=10e3),
                   ctdna=list(a=1, b=9),
                   chip=list(a=1, b=9),
                   montecarlo.samples=50e3,
                   prior.weight=0.1)

## ----montecarlo---------------------------------------------------------------
stats <- importance_sampler(dat$data[[1]], param.list)
## Just the mutation-level summary statistics (marginal likelihoods and bayes factors)
importance_sampler(dat$data[[1]], param.list, save_montecarlo=FALSE)

## ----prior.weight, cache=TRUE-------------------------------------------------
fun <- function(montecarlo.samples, data,
                param.list, prior.weight=0.1){
    param.list$montecarlo.samples <- montecarlo.samples
    param.list$prior.weight <- prior.weight
    res <- importance_sampler(data, param.list,
                              save_montecarlo=FALSE) %>%
        mutate(montecarlo.samples=montecarlo.samples,
               prior.weight=param.list$prior.weight)
    res
}
fun2 <- function(montecarlo.samples, data,
                 param.list, prior.weight=0.1,
                 nreps=100){
    res <- replicate(nreps, fun(montecarlo.samples, data,
                                param.list,
                                prior.weight=prior.weight),
                     simplify=FALSE) %>%
        do.call(bind_rows, .) %>%
        group_by(montecarlo.samples, prior.weight) %>%
        summarize(mean_bf=mean(bayesfactor),
                  sd_bf=sd(bayesfactor),
                  .groups="drop")
    res
}
S <- c(100, 1000, seq(10e3, 50e3, by=10000))
results <- S %>%
    map_dfr(fun2, data=dat$data[[1]], param.list=param.list)
results2 <- S %>%
    map_dfr(fun2, data=dat$data[[1]], param.list=param.list,
            prior.weight=1)
combined <- bind_rows(results, results2)

## ----standardev, fig.width=8, fig.height=5------------------------------------
combined %>%
    mutate(prior.weight=factor(prior.weight)) %>%
    ggplot(aes(montecarlo.samples, sd_bf)) +
    geom_point(aes(color=prior.weight)) +
    geom_line(aes(group=prior.weight, color=prior.weight)) +
    scale_y_log10() +
    theme_bw(base_size=16) +
    xlab("Monte Carlo samples") +
    ylab("Standard deviation of\n log Bayes Factor")

## ----means, fig.width=8, fig.height=5-----------------------------------------
combined %>%
    mutate(prior.weight=factor(prior.weight)) %>%
    filter(montecarlo.samples > 100) %>%
    ggplot(aes(prior.weight, mean_bf)) +
    geom_point() +
    theme_bw(base_size=16) +
    ylab("Mean log Bayes factor") +
    xlab("Prior weight")

## ----vanterve-----------------------------------------------------------------
data(crcseq, package="plasmut")
crcseq %>% select(-position)

## ----vanterve-importance-sampling---------------------------------------------
params <- list(ctdna = list(a = 1, b = 9), 
               ctc = list(a = 1, b = 10^3), 
               chip = list(a= 1, b = 9), 
               montecarlo.samples = 50e3, 
               prior.weight = 0.1)
muts <- unite(crcseq, "uid", c(patient, gene), remove = FALSE) %>% 
        group_by(uid) %>% nest()
#Each element of the data column contains a table with the variant and total allele counts in plasma and buffy coat. 
#Run the importance sampler
muts$IS <- muts$data %>% map(importance_sampler, params)
fun <- function(x){
    result <- x$data %>%
        select(-position) %>%
        mutate(bayes_factor = x$IS$bayesfactor$bayesfactor)
    return(result)
}
bf <- apply(muts, 1, fun) 
bf %>% do.call(rbind, .) %>%
    as_tibble() %>%
    select(patient, gene, aa, bayes_factor) %>%
    rename(log_bf=bayes_factor) %>%
    distinct()

## ----session------------------------------------------------------------------
sessionInfo()

#' Bayesian models for estimating the origin of a sequenced DNA fragment
#'
#' The plasmut package provides a Bayesian importance sampling based approach 
#' to estimate the liklihood of a mutation arising from clonal hematopoiesis
#' or tumor
#' @docType package
#' @name plasmut
#' @import tibble
#' @importFrom dplyr filter bind_rows
#' @importFrom stats rbeta rbinom dbeta dbinom setNames
NULL

#' This data is an example dataset to show how to use the package
#'
#'
#' A cohort of metastatic colorectal cancer patients whose plasma and buffy 
#' coat were sequenced as part of the CAIRO5 trial. 
#' The cohort and analyses are described here: 
#' \url{https://pubmed.ncbi.nlm.nih.gov/36534496/}
#'
#'
#'
#' @docType data
#' @name crcseq
#' @return An example DNA sequencing dataset of matched plasma 
#' and wbc colorectal cancer samples
#' crcseq
NULL

importance_samples <- function(y, n,
                               a, b,
                               S,
                               prior.weight,
                               model,
                               dna_source){
    a.n <- a + y
    b.n <- n - y + b
    x <- rbinom(S, 1, prior.weight)
    g.samples <- rep(NA, S)
    g.samples[x==1] <- rbeta(sum(x), a, b)
    g.samples[x==0] <- rbeta(S-sum(x), a.n, b.n)
    ## probability of CTC
    posterior.samples <- rbeta(S, a.n, b.n)
    prior.samples <- rbeta(S, a, b)
    ##
    ## probability of theta with respect to prior and posterior
    ## p(theta | model )
    ##
    g.prob.posterior <- dbeta(g.samples, a.n, b.n)
    g.prob.prior <- dbeta(g.samples, a, b)
    ## the density of g is the mixture density
    lik <- dbinom(y, n, g.samples)
    ## probability of theta with respect to g
    g.density <- prior.weight * g.prob.prior +
        (1-prior.weight) * g.prob.posterior
    result <- lik * g.prob.prior / g.density
    ml <- mean(result)
    samples <- tibble(posterior=posterior.samples,
                      prior=prior.samples,
                      g=g.samples,
                      model=model,
                      dna_source=dna_source)
    densities <- tibble(posterior=g.prob.posterior,
                        prior=g.prob.prior,
                        g=g.density,
                        x=x,
                        lik=lik,
                        model=model,
                        dna_source=dna_source)
    result <- list(samples=samples,
                   densities=densities,
                   marglik=ml)
    result
}

#' Estimate the marginal likelihood of observing somatic mutations
#' from CTCs present in buffy coat
#' p(y_w | theta_w, n_w, model_S) x p(theta_w| Model_S)
#' theta_w | model_S  ~ beta(1, 999)  ## sequencing error or CTC
#' @param dat tibble containing vectors `y`and `n`; `y` and `n` should be named
#' @param params a list with named elements that must include the following:
#' `a`: prior expectation for number of somatic variants
#' observed in the WBC sequencing data (either by error or from a CTC)
#' `b`: prior expectation for number of WBCs not containing the variant
#' @examples
#' param.list <- list(ctc=list(a=1, b=9999),
#'                    ctdna=list(a=1, b=9),
#'                    chip=list(a=1, b=9),
#'                    montecarlo.samples=50e3,
#'                    prior.weight=0.1)
#' dat <- data.frame(y=c(4, 1),
#'               n=c(1000, 1000),
#'               analyte=c("plasma", "buffy coat"),
#'               mutation="mutA",
#'               sample_id="id1")
#' wbc_somatic(dat, param.list)
#' @return generate importance samples for wbc somatic model
#' @export
wbc_somatic <- function(dat, params){
    # asssume we observed y_w=500 and n_w = 1000
    # This is clearly germline, but to go through the machinery,
    # we would obtain the probability of observing 500 somatic
    # variants (y_w) under a model where the prior for theta_w
    # has most of the mass near zero
    # The importance sampler does not really make sense here as it samples
    # from a distribution that is fatter tailed than the posterior
    S <- params$montecarlo.samples
    prior.weight <- params$prior.weight
    params <- params$ctc
    dat <- dplyr::filter(dat, analyte=="buffy coat")
    y <- dat$y
    n <- dat$n
    a <- params$a
    b <- params$b
    analyte <- NULL
    result <- importance_samples(y, n,
                                 a, b,
                                 S,
                                 prior.weight,
                                 model="Somatic",
                                 dna_source="CTC")
}

#' Estimate the marginal likelihood that variants identified in
#' cell-free DNA are derived from tumor cells (ctDNA-derived)
#' @param dat tibble containing vectors `y`and `n`; `y` and `n` should be named
#' @param params a list with named elements that must include the following:
#' `a`: prior expectation for number of plasma somatic variants
#' observed in the plasma sequencing data
#' `b`: prior expectation for number of plasma fragments 
#' not containing variants
#' @examples
#' param.list <- list(ctc=list(a=1, b=9999),
#'                    ctdna=list(a=1, b=9),
#'                    chip=list(a=1, b=9),
#'                    montecarlo.samples=50e3,
#'                    prior.weight=0.1)
#' dat <- data.frame(y=c(4, 1),
#'               n=c(1000, 1000),
#'               analyte=c("plasma", "buffy coat"),
#'               mutation="mutA",
#'               sample_id="id1")
#' plasma_somatic(dat, param.list)
#' @return generate importance samples for plasma somatic model
#' @export
plasma_somatic <- function(dat, params){
    prior.weight <- params$prior.weight
    S <- params$montecarlo.samples
    params <- params$ctdna
    analyte <- NULL
    dat <- dplyr::filter(dat, analyte=="plasma")
    y <- dat$y
    n <- dat$n
    a <- params$a
    b <- params$b
    result <- importance_samples(y, n,
                                 a, b,
                                 S,
                                 prior.weight,
                                 model="Somatic",
                                 dna_source="ctDNA")
    return(result)
}

#' Estimate the marginal likelihood that mutations in buffy coat
#' and cfDNA reflect CH or correspond to germline mutations.
#' If germline, the allele frequency should be 50 percent.
#' The prior should be diffuse enough to handle CHIP mutations which are
#' potentially way less than 50 percent
#' @param dat tibble containing vectors yand n. y and n should be named
#' @param params a list with named elements that must include the following
#' a which is the prior expectation for number of CH or germline variants
#' observed in the sequencing data
#' b which is the prior expectation for number of fragments
#' reflecting CH or germline
#' @examples
#' param.list <- list(ctc=list(a=1, b=9999),
#'                    ctdna=list(a=1, b=9),
#'                    chip=list(a=1, b=9),
#'                    montecarlo.samples=50e3,
#'                    prior.weight=0.1)
#' dat <- data.frame(y=c(4, 1),
#'               n=c(1000, 1000),
#'               analyte=c("plasma", "buffy coat"),
#'               mutation="mutA",
#'               sample_id="id1")
#' model_w(dat, param.list)
#' @return list of samples, probability densities, and likelihood for non-tumor
#' assumption
#' @export
model_w <- function(dat, params){
    #We use g to propose values of theta and evaluate the
    #likelihood of the observed data in plasma and WBCs given this value
    #If we use a beta (1, 10) for example
    #this should be diffuse enough to capture germline
    prior.weight <- params$prior.weight
    S <- params$montecarlo.samples
    params <- params$chip
    y <- setNames(dat$y, dat$analyte)
    n <- setNames(dat$n, dat$analyte)
    a <- params$a
    b <- params$b
    ##
    ## With single theta and conjugate (beta) prior, posterior is
    ## beta(a + y_w + y_p, b + (n.w + n.p)-(y.w+y.p))
    ##
    a.n <- a + sum(y)
    b.n <- sum(n)- sum(y) + b
    g.samples <- rep(NA, S)
    x <- rbinom(S, 1, prior.weight)
    g.samples[x == 1] <- rbeta(sum(x), a, b)
    g.samples[x == 0] <- rbeta(S-sum(x), a.n, b.n)
    prior.samples <- rbeta(S, a, b)
    posterior.samples <- rbeta(S, a.n, b.n)
    ##
    ##
    ##
    g.prob.posterior <- dbeta(g.samples, a.n, b.n)
    g.prob.prior <- dbeta(g.samples, a, b)
    g.density <- prior.weight * g.prob.prior +
        (1-prior.weight)*g.prob.posterior
    not.finite <- !is.finite(g.density)
    if(any(not.finite)) warning("Not finite")
    loglik.p <- dbinom(y["plasma"], n["plasma"], g.samples, log=TRUE)
    loglik.w <- dbinom(y["buffy coat"], n["buffy coat"], g.samples, log=TRUE)
    lik <- exp(loglik.p + loglik.w)
    result <- lik * g.prob.prior/g.density
    ml <- mean(result)
    samples <- tibble(posterior=posterior.samples,
                      prior=prior.samples,
                      g=g.samples,
                      model="WBC",
                      dna_source="WBC")
    densities <- tibble(posterior=g.prob.posterior,
                        prior=g.prob.prior,
                        g=g.density,
                        x=x,
                        lik=lik,
                        model="WBC",
                        dna_source="WBC")
    result <- list(samples=samples,
                   densities=densities,
                   marglik=ml)
    result
}

#' Importance sampler to estimate marginal likelihoods and Bayes factors
#'
#' @examples
#' param.list <- list(ctc=list(a=1, b=9999),
#'                    ctdna=list(a=1, b=9),
#'                    chip=list(a=1, b=9),
#'                    montecarlo.samples=50e3,
#'                    prior.weight=0.1)
#' dat <- data.frame(y=c(4, 1),
#'               n=c(1000, 1000),
#'               analyte=c("plasma", "buffy coat"),
#'               mutation="mutA",
#'               sample_id="id1")
#' importance_sampler(dat, param.list)
#'
#'
#'
#' @param dat data frame with observed mutant and total counts and
#' the analyte (plasma or buffy coat) it was taken from and the
#' identifiers on what the mutation is (e.g., KRASG12C) and pt id
#' @param params list with ctc, ctdna and chip a and b beta parameters reflect
#' beliefs on what fraction of fragments belong to each class;
#' montecarlo.samples being the number of MC samples; prior weight is the
#' prior.weight reflects how much importance sampling to implement, closer to
#' zero means more importance density considered
#' @param save_montecarlo save more indepth monte carlo results
#' @return implement importance sampling for a data set to assess probability 
#' of tumor derived mutations from sequencing results
#' @export
importance_sampler <- function(dat, params, save_montecarlo=TRUE){
    ##
    ## Probability we see a somatic alteration when
    ## sequencing WBCs
    A <- wbc_somatic(dat, params)
    ## Probability we see the somatic alteration in
    ## cfDNA
    B <- plasma_somatic(dat, params)
    ml.tumor <- log(A$marglik) + log(B$marglik)
    ##ns.params <- nonsomatic_params(1, 10, gamma=0.2)
    model.not.tumor <- model_w(dat, params)
    ml.not.tumor <- log(model.not.tumor$marglik)
    bf <- ml.tumor - ml.not.tumor
    stats <- tibble(ctc=log(A$marglik),
                    ctdna=log(B$marglik),
                    chip=log(model.not.tumor$marglik),
                    bayesfactor=bf)
    if(!save_montecarlo) return(stats)
    densities <- bind_rows(A$densities,
                           B$densities,
                           model.not.tumor$densities)
    samples <- bind_rows(A$samples,
                         B$samples,
                         model.not.tumor$samples)
    list(data=dat,
         densities=densities,
         samples=samples,
         bayesfactor=stats,
         params=params)
}

test_that("correct bayes factor computation", {

  param.list <- list(ctc=list(a=1, b=9999),
                      ctdna=list(a=1, b=9),
                      chip=list(a=1, b=9),
                      montecarlo.samples=50e3,
                      prior.weight=0.1)

   dat <- data.frame(y=c(4, 1),
                 n=c(1000, 1000),
                 analyte=c("plasma", "buffy coat"),
                 mutation="mutA",
                 sample_id="id1")

  output <- importance_sampler(dat, param.list)


  expect_equal(output$bayesfactor$bayesfactor, 0.0410561, tolerance = 0.05)


})

---
title: "Modeling the origin of mutations identified in a liquid biopsy: cancer or clonal hematopoiesis?"
author: "Adith S. Arun and Robert B. Scharpf"
date: "`r format(Sys.Date())`"
output: BiocStyle::html_document
abstract: >
  Mutation-based approaches for detection of cancer from cell-free DNA (cfDNA) using liquid biopsies have the potential to track a patient's response to treatment, enabling effective and timely decisions on therapy.  However, mutations arising from clonal hematopoeisis (CH) are common and tumor biopsies for definitive identification of the origin of these mutations is not always available. Sequencing of matched cells from buffy coat and the absence of mutations in these cells has been used as a test to rule-out CH, but uneven sequencing depths between matched cell-free DNA and buffy coat samples and the potential for contamination of buffy coat with circulating tumor cells (CTCs) are not captured by rule-based analyses.  This package estimates Bayes factors that weigh the evidence of competing CH- and tumor-origin models of cfDNA mutations detected in cfDNA, requiring only the allele frequencies of high quality alignments available from standard mutation callers.
vignette: >
  %\VignetteIndexEntry{Modeling the origin of mutations in a liquid biopsy: cancer or clonal hematopoiesis?}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography:  arun2023.bib
---

# Motivating example

Assume mutation analyses identify four fragments with a *TP53* variant out of 1000 fragments overlapping that position.
In matched WBC sequencing, we observed no fragments with this mutation out of 600 distinct fragments spanning this position.
While *TP53* is a well-known tumor suppressor, mutations in *TP53* are also common in CH.
Given the mutant allele frequencies in cfDNA and matched buffy coat sequencing and prior studies, how strong is the evidence that the *TP53* mutation is tumor-derived?

# Installation

Install the plasmut package from Bioconductor

```{r installation, eval = FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("plasmut")
```

# Data organization

```{r setup, message=FALSE}
library(magrittr)
library(tidyverse)
library(plasmut)
knitr::opts_chunk$set(cache=TRUE)
lo <- function(p) log(p/(1-p))
```

We assume the following minimal representation for the mutation data such that each row uniquely identifies a mutation within a sample.

```{r data_wrangling}
## sample data
p53 <- tibble(y=c(4, 0),
              n=c(1000, 600),
              analyte=c("plasma", "buffy coat"),
              mutation="TP53",
              sample_id="id1")
dat <- p53 %>%
    unite("uid", c(sample_id, mutation), remove=FALSE) %>%
    group_by(uid) %>%
    nest()
## required format for plasmut
dat
```


# Approach and implementation

## Bayesian model

Let ($y_p$, $n_p$) denote the number of mutant reads and total number of distinct reads in plasma and ($y_w$, $n_w$) the corresponding frequencies from the buffy coat.
Assuming that the mutation is either tumor- or CH-derived, the posterior odds is given by
$$\frac{p(S | y_p, y_w, n_p, n_w)}{p(H | y_p, y_w, n_p, n_w)} = \frac{p(y_w, y_p | n_p, n_w, S)}{p(y_w, y_p | n_p, n_w, H)} \cdot \frac{p(S)}{p(H)}, $$
where *S* indicates the somatic (tumor-derived) model and H denotes the hematopietic (CH-derived) model.
The term $\frac{p(y_w, y_p | n_p, n_w, S)}{p(y_w, y_p | n_p, n_w, H)}$ is the Bayes factor and is a ratio of the marginal likelihoods.
For the denominator, we assume that the unobserved true mutant allele frequency ($\theta$) in plasma is the same as the mutant allele frequency in buffy coat and rewrite the marginal likelihood as $\int_{\theta} p(y_p | \theta, n_p) p(y_w | \theta,  n_w) p(\theta | H)d\theta$.
We suggest a diffuse prior for $\theta$ to provide support for both rare and common CH mutations. 

For model *S*, the marginal likelihood is factored as $\int_{\theta_p} p(y_p | n_p, \theta_p) p(\theta_p | S)d\theta_p\int_{\theta_w} p(y_w | n_w, \theta_w) p(\theta_w | S) d\theta_w$.
A diffuse prior for $\theta_p$ allows support for both rare and common somatic mutations.
Under model $S$, $\theta_W$ is $> 0$ if circulating tumor cells (CTCs) are inter-mixed with white blood cells in the buffy coat.
As CTCs tend to be uncommon even in patients with late-stage disease, we suggest a prior distribution that concentrates most of the mass near zero (i.e., Beta(1, $10^3$)).

## Implementation

We can compute marginal likelihoods for model $S$ and $H$ by simply drawing Monte Carlo samples from the priors and approximating the above integrals by the mean. 
However, when the likelihood is much more concentrated than the prior, this sampling approach can be inefficient and numerically unstable. 
To mitigate these issues, we implemented an importance sampling approach where the target distribution for the importance sampler is a weighted average of the prior and posterior. 
The resulting mixture distribution has a shape similar to the posterior but with fatter tails.
As the target distribution ensures that we sample values of $\theta$ where the posterior has a positive likelihood, approximation of the marginal likelihoods is more accurate with fewer Monte Carlo simulations.

In the following code block, we assume that
(1) the probability that CTCs are mixed in with the WBCs is small (e.g., 1 CTC per 1,000 cells) using a Beta(1, 10^3) prior,
(2) the prior for $\theta_p$ is relatively diffuse (Beta(1, 9)), and
(3) the prior for germline or CHIP variants in WBCs is also relatively diffuse (Beta(1, 9)).
A mixture weight of 0.1 for the prior (`prior.weight`) concentrates most of the mass of the target distribution on the posterior:
```{r parameters}
## Parameters
param.list <- list(ctc=list(a=1, b=10e3),
                   ctdna=list(a=1, b=9),
                   chip=list(a=1, b=9),
                   montecarlo.samples=50e3,
                   prior.weight=0.1)
```

Next, we estimate the marginal likelihood for the mutation frequencies under the $S$ and $H$ models and return all Monte Carlo samples in a list.
For running this model on datasets with a large number of candidate tumor-derived mutations, we recommend saving only the marginal likelihoods and Bayes factors by setting  `save_montecarlo=FALSE`.

```{r montecarlo}
stats <- importance_sampler(dat$data[[1]], param.list)
## Just the mutation-level summary statistics (marginal likelihoods and bayes factors)
importance_sampler(dat$data[[1]], param.list, save_montecarlo=FALSE)
```

We view the plasma MAF of 4/1000 and buffy coat MAF of 0/600 as weak evidence that the mutation is tumor derived (Bayes factor  = `r round(exp(stats$bayesfactor$bayesfactor), 2)`).
As previous studies have demonstrated that *TP53* mutations are common in CH, our prior odds is 1 and so the posterior odds for the tumor-origin model is the same as the Bayes factor, `r round(exp(stats$bayesfactor$bayesfactor), 2)`.

## Efficiency of importance sampler

As long as `montecarlo.samples` is big enough, we should obtain a similar estimate of the marginal likelihood without importance sampling.
Since our target distribution $g$ is a mixture of the prior and posterior with weight `prior.weight`, setting `prior.weight=1` just samples $\theta$'s from our prior (i.e., importance sampling is not implemented).  Below, we compare the stability of the Bayes factor estimate as a function of the Monte Carlo sample size and prior weight:

```{r prior.weight, cache=TRUE}
fun <- function(montecarlo.samples, data,
                param.list, prior.weight=0.1){
    param.list$montecarlo.samples <- montecarlo.samples
    param.list$prior.weight <- prior.weight
    res <- importance_sampler(data, param.list,
                              save_montecarlo=FALSE) %>%
        mutate(montecarlo.samples=montecarlo.samples,
               prior.weight=param.list$prior.weight)
    res
}
fun2 <- function(montecarlo.samples, data,
                 param.list, prior.weight=0.1,
                 nreps=100){
    res <- replicate(nreps, fun(montecarlo.samples, data,
                                param.list,
                                prior.weight=prior.weight),
                     simplify=FALSE) %>%
        do.call(bind_rows, .) %>%
        group_by(montecarlo.samples, prior.weight) %>%
        summarize(mean_bf=mean(bayesfactor),
                  sd_bf=sd(bayesfactor),
                  .groups="drop")
    res
}
S <- c(100, 1000, seq(10e3, 50e3, by=10000))
results <- S %>%
    map_dfr(fun2, data=dat$data[[1]], param.list=param.list)
results2 <- S %>%
    map_dfr(fun2, data=dat$data[[1]], param.list=param.list,
            prior.weight=1)
combined <- bind_rows(results, results2)
```


```{r standardev, fig.width=8, fig.height=5}
combined %>%
    mutate(prior.weight=factor(prior.weight)) %>%
    ggplot(aes(montecarlo.samples, sd_bf)) +
    geom_point(aes(color=prior.weight)) +
    geom_line(aes(group=prior.weight, color=prior.weight)) +
    scale_y_log10() +
    theme_bw(base_size=16) +
    xlab("Monte Carlo samples") +
    ylab("Standard deviation of\n log Bayes Factor")
```

Note that with importance sampling, relatively stable estimates for the Bayes factor are obtained with as few as 10,000 Monte Carlo samples while sampling from the prior distribution is very unstable for small sample sizes.

```{r means, fig.width=8, fig.height=5}
combined %>%
    mutate(prior.weight=factor(prior.weight)) %>%
    filter(montecarlo.samples > 100) %>%
    ggplot(aes(prior.weight, mean_bf)) +
    geom_point() +
    theme_bw(base_size=16) +
    ylab("Mean log Bayes factor") +
    xlab("Prior weight")
```


# Application to van't Erve et al.

We illustrate this approach on a dataset of cfDNA and matched buffy coat sequencing for patients with metastatic colorectal cancer [@vanterve2023].
Below, we select four mutations and run the importance sampler for these candidate mutations independently.

```{r vanterve}
data(crcseq, package="plasmut")
crcseq %>% select(-position)
```

```{r vanterve-importance-sampling}
params <- list(ctdna = list(a = 1, b = 9), 
               ctc = list(a = 1, b = 10^3), 
               chip = list(a= 1, b = 9), 
               montecarlo.samples = 50e3, 
               prior.weight = 0.1)
muts <- unite(crcseq, "uid", c(patient, gene), remove = FALSE) %>% 
        group_by(uid) %>% nest()
#Each element of the data column contains a table with the variant and total allele counts in plasma and buffy coat. 
#Run the importance sampler
muts$IS <- muts$data %>% map(importance_sampler, params)
fun <- function(x){
    result <- x$data %>%
        select(-position) %>%
        mutate(bayes_factor = x$IS$bayesfactor$bayesfactor)
    return(result)
}
bf <- apply(muts, 1, fun) 
bf %>% do.call(rbind, .) %>%
    as_tibble() %>%
    select(patient, gene, aa, bayes_factor) %>%
    rename(log_bf=bayes_factor) %>%
    distinct()
```

For the E1306\* *APC* mutation,  395 of 1750 fragments in cfDNA contain the mutation while zero of 963 fragments from buffy coat contain this mutation.
The evidence that E1306\* is tumor-derived is definitive (log Bayes factor = 190).
For the M237K *TP53* mutation, we observe 5 mutations out of 1495 fragments in buffy coat and 15 mutations out of 2969 fragments in cfDNA.
The observed mutant read rate is roughly equal in WBC and cfDNA, providing further evidence that the variant likely originates from CH.
As indicated by our prior, we feel that a high CTC fraction in buffy coat is very unlikely given the rarity of CTCs relative to white blood cells in buffy coat.
The log Bayes factor (equivalent to the posterior log odds assuming a prior odds of 1) is -1.14.
The probability that the mutation is tumor-derived is only 0.25 ($\frac{exp(-1.14)}{exp(-1.14) + 1}$ or 0.24).

# Session information

```{r session}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importance_sampler.R
\name{model_w}
\alias{model_w}
\title{Estimate the marginal likelihood that mutations in buffy coat
and cfDNA reflect CH or correspond to germline mutations.
If germline, the allele frequency should be 50 percent.
The prior should be diffuse enough to handle CHIP mutations which are
potentially way less than 50 percent}
\usage{
model_w(dat, params)
}
\arguments{
\item{dat}{tibble containing vectors yand n. y and n should be named}

\item{params}{a list with named elements that must include the following
a which is the prior expectation for number of CH or germline variants
observed in the sequencing data
b which is the prior expectation for number of fragments
reflecting CH or germline}
}
\value{
list of samples, probability densities, and likelihood for non-tumor
assumption
}
\description{
Estimate the marginal likelihood that mutations in buffy coat
and cfDNA reflect CH or correspond to germline mutations.
If germline, the allele frequency should be 50 percent.
The prior should be diffuse enough to handle CHIP mutations which are
potentially way less than 50 percent
}
\examples{
param.list <- list(ctc=list(a=1, b=9999),
                   ctdna=list(a=1, b=9),
                   chip=list(a=1, b=9),
                   montecarlo.samples=50e3,
                   prior.weight=0.1)
dat <- data.frame(y=c(4, 1),
              n=c(1000, 1000),
              analyte=c("plasma", "buffy coat"),
              mutation="mutA",
              sample_id="id1")
model_w(dat, param.list)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importance_sampler.R
\name{importance_sampler}
\alias{importance_sampler}
\title{Importance sampler to estimate marginal likelihoods and Bayes factors}
\usage{
importance_sampler(dat, params, save_montecarlo = TRUE)
}
\arguments{
\item{dat}{data frame with observed mutant and total counts and
the analyte (plasma or buffy coat) it was taken from and the
identifiers on what the mutation is (e.g., KRASG12C) and pt id}

\item{params}{list with ctc, ctdna and chip a and b beta parameters reflect
beliefs on what fraction of fragments belong to each class;
montecarlo.samples being the number of MC samples; prior weight is the
prior.weight reflects how much importance sampling to implement, closer to
zero means more importance density considered}

\item{save_montecarlo}{save more indepth monte carlo results}
}
\value{
implement importance sampling for a data set to assess probability 
of tumor derived mutations from sequencing results
}
\description{
Importance sampler to estimate marginal likelihoods and Bayes factors
}
\examples{
param.list <- list(ctc=list(a=1, b=9999),
                   ctdna=list(a=1, b=9),
                   chip=list(a=1, b=9),
                   montecarlo.samples=50e3,
                   prior.weight=0.1)
dat <- data.frame(y=c(4, 1),
              n=c(1000, 1000),
              analyte=c("plasma", "buffy coat"),
              mutation="mutA",
              sample_id="id1")
importance_sampler(dat, param.list)



}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/help.R
\docType{package}
\name{plasmut}
\alias{plasmut}
\title{Bayesian models for estimating the origin of a sequenced DNA fragment}
\description{
The plasmut package provides a Bayesian importance sampling based approach 
to estimate the liklihood of a mutation arising from clonal hematopoiesis
or tumor
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importance_sampler.R
\name{wbc_somatic}
\alias{wbc_somatic}
\title{Estimate the marginal likelihood of observing somatic mutations
from CTCs present in buffy coat
p(y_w | theta_w, n_w, model_S) x p(theta_w| Model_S)
theta_w | model_S  ~ beta(1, 999)  ## sequencing error or CTC}
\usage{
wbc_somatic(dat, params)
}
\arguments{
\item{dat}{tibble containing vectors `y`and `n`; `y` and `n` should be named}

\item{params}{a list with named elements that must include the following:
`a`: prior expectation for number of somatic variants
observed in the WBC sequencing data (either by error or from a CTC)
`b`: prior expectation for number of WBCs not containing the variant}
}
\value{
generate importance samples for wbc somatic model
}
\description{
Estimate the marginal likelihood of observing somatic mutations
from CTCs present in buffy coat
p(y_w | theta_w, n_w, model_S) x p(theta_w| Model_S)
theta_w | model_S  ~ beta(1, 999)  ## sequencing error or CTC
}
\examples{
param.list <- list(ctc=list(a=1, b=9999),
                   ctdna=list(a=1, b=9),
                   chip=list(a=1, b=9),
                   montecarlo.samples=50e3,
                   prior.weight=0.1)
dat <- data.frame(y=c(4, 1),
              n=c(1000, 1000),
              analyte=c("plasma", "buffy coat"),
              mutation="mutA",
              sample_id="id1")
wbc_somatic(dat, param.list)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{crcseq}
\alias{crcseq}
\title{This data is an example dataset to show how to use the package}
\value{
An example DNA sequencing dataset of matched plasma 
and wbc colorectal cancer samples
crcseq
}
\description{
A cohort of metastatic colorectal cancer patients whose plasma and buffy 
coat were sequenced as part of the CAIRO5 trial. 
The cohort and analyses are described here: 
\url{https://pubmed.ncbi.nlm.nih.gov/36534496/}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importance_sampler.R
\name{plasma_somatic}
\alias{plasma_somatic}
\title{Estimate the marginal likelihood that variants identified in
cell-free DNA are derived from tumor cells (ctDNA-derived)}
\usage{
plasma_somatic(dat, params)
}
\arguments{
\item{dat}{tibble containing vectors `y`and `n`; `y` and `n` should be named}

\item{params}{a list with named elements that must include the following:
`a`: prior expectation for number of plasma somatic variants
observed in the plasma sequencing data
`b`: prior expectation for number of plasma fragments 
not containing variants}
}
\value{
generate importance samples for plasma somatic model
}
\description{
Estimate the marginal likelihood that variants identified in
cell-free DNA are derived from tumor cells (ctDNA-derived)
}
\examples{
param.list <- list(ctc=list(a=1, b=9999),
                   ctdna=list(a=1, b=9),
                   chip=list(a=1, b=9),
                   montecarlo.samples=50e3,
                   prior.weight=0.1)
dat <- data.frame(y=c(4, 1),
              n=c(1000, 1000),
              analyte=c("plasma", "buffy coat"),
              mutation="mutA",
              sample_id="id1")
plasma_somatic(dat, param.list)
}
